
#ifndef RISCOS

#include "stdafx.h"

#endif

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <malloc.h>
#include <string.h>

#include "os.h"

#include "etc.h"
#include "bits.h"

#include "deb.h"

#include "rtftype.h"
#include "rtfdecl.h"

#include "rtfreadr.h"


#include "TransRTF.h"


int  cGroup;
bool fSkipDestIfUnk;
long cbBin;
long lParam;

int  unicodeskip;
int  risUnicode;


RDS rds;
RIS ris;

CHP chp;
PAP pap;
SEP sep;
DOP dop;

TAB tabruler;


SSTACK sstack;

SAVE *psave;


static FILE * fpout;


static void txendstring(void);
static void txflushstyle(void);
static void txflush(int split);
static void txflushall(void);



//
// %%Function: ecRtfParse
//
// Step 1:
// Isolate RTF keywords and send them to ecParseRtfKeyword;
// Push and pop state at the start and end of RTF groups;
// Send text to ecParseChar for further processing.
//


int ecRtfParse(FILE *fp)
{
    int ch;
    int ec;
    int cNibble = 2;
    int b = 0;
    while ((ch = getc(fp)) != EOF)
    {
        if (cGroup < 0)
            return ecStackUnderflow;
        if (ris == risBin)                      // if we're parsing binary data, handle it directly
        {
            if ((ec = ecParseChar(ch,0)) != ecOK)
                return ec;
        }
        else
        {
            switch (ch)
            {
            case '{':
																if(risUnicode) risUnicode=0;
                if ((ec = ecPushRtfState()) != ecOK)
                    return ec;
                break;

            case '}':
																if(risUnicode) risUnicode=0;
                if ((ec = ecPopRtfState()) != ecOK)
                    return ec;
                break;

            case '\\':
                if ((ec = ecParseRtfKeyword(fp)) != ecOK)
                    return ec;
                break;
            case 0x0d:
            case 0x0a:          // cr and lf are noise characters...
                break;

            default:
                if (ris == risNorm)
                {
                    if ((ec = ecParseChar(ch,0)) != ecOK)
                        return ec;
                }
                else
                {               // parsing hex data
                    if (ris != risHex)
                        return ecAssertion;
                    b = b << 4;
                    if (isdigit(ch))
                        b += (char) ch - '0';
                    else
                    {
                        if (islower(ch))
                        {
                            if (ch < 'a' || ch > 'f')
                                return ecInvalidHex;
                            b += (char) ch - 'a'+10;
                        }
                        else
                        {
                            if (ch < 'A' || ch > 'F')
                                return ecInvalidHex;
                            b += (char) ch - 'A'+10;
                        }
                    }

//																				cprintf("nibble b=%x n=%d ch=%c",b,cNibble,ch);

                    cNibble--;
                    if (!cNibble)
                    {


                        if ((ec = ecParseChar(b,0)) != ecOK)
                            return ec;
                        cNibble = 2;
                        b = 0;
                     ris = risNorm;
                    }
                }                   // end else (ris != risNorm)
                break;
            }       // switch
        }           // else (ris != risBin)
    }               // while
    if (cGroup < 0)
        return ecStackUnderflow;
    if (cGroup > 0)
        return ecUnmatchedBrace;
    return ecOK;
}

//
// %%Function: ecPushRtfState
//
// Save relevant info on a linked list of SAVE structures.
//

int ecPushRtfState(void)
{
// cprintf("push state");

    SAVE *psaveNew = (SAVE*)malloc(sizeof(SAVE));
    if (!psaveNew)
        return ecStackOverflow;

    psaveNew -> pNext=psave;
    psaveNew -> chp=chp;
    psaveNew -> pap=pap;
    psaveNew -> sep=sep;
    psaveNew -> dop=dop;
    psaveNew -> rds=rds;
    psaveNew -> ris=ris;
    psaveNew -> sstack=sstack;
    ris=risNorm;
    psave=psaveNew;
    cGroup++;
    return ecOK;
}

//
// %%Function: ecPopRtfState
//
// If we're ending a destination (that is, the destination is changing),
// call ecEndGroupAction.
// Always restore relevant info from the top of the SAVE list.
//

int ecPopRtfState(void)
{
    SAVE *psaveOld;
    int ec;

// cprintf("pop state");

    if (!psave)
        return ecStackUnderflow;

// cprintf("pop state1");

    if (rds != psave->rds)
    {
        if ((ec = ecEndGroupAction(rds)) != ecOK)
            return ec;
    }
    chp=psave->chp;
    pap=psave->pap;
    sep=psave->sep;
    dop=psave->dop;
    rds=psave->rds;
    ris=psave->ris;
    sstack=psave->sstack;
    stylechange();
// cprintf("pop state2");


    psaveOld = psave;

//cprintf("psave %x",psave);
    psave = psave->pNext;

// cprintf("pop state3 %x",psaveOld);    
    cGroup--;
    free(psaveOld);

// cprintf("pop stateX");

    return ecOK;
}

//
// %%Function: ecParseRtfKeyword
//
// Step 2:
// get a control word (and its associated value) and
// call ecTranslateKeyword to dispatch the control.
//

int ecParseRtfKeyword(FILE *fp)
{
    int ch;
    char fParam = fFalse;
    char fNeg = fFalse;
    int param = 0;
    char *pch;
    char szKeyword[30];
    char szParameter[20];

    szKeyword[0] = '\0';
    szParameter[0] = '\0';
    if ((ch = getc(fp)) == EOF)
        return ecEndOfFile;
    if (!isalpha(ch))           // a control symbol; no delimiter.
    {
        szKeyword[0] = (char) ch;
        szKeyword[1] = '\0';


        return ecTranslateKeyword(szKeyword, 0, fParam);
    }
    for (pch = szKeyword; isalpha(ch); ch = getc(fp))
        *pch++ = (char) ch;
    *pch = '\0';
    if (ch == '-')
    {
        fNeg  = fTrue;
        if ((ch = getc(fp)) == EOF)
            return ecEndOfFile;
    }
    if (isdigit(ch))
    {
        fParam = fTrue;         // a digit after the control means we have a parameter
        for (pch = szParameter; isdigit(ch); ch = getc(fp))
            *pch++ = (char) ch;
        *pch = '\0';
        param = atoi(szParameter);
        if (fNeg)
            param = -param;
        lParam = atol(szParameter);
        if (fNeg)
            param = -param;
    }
    if (ch != ' ')
        ungetc(ch, fp);

    return ecTranslateKeyword(szKeyword, param, fParam);
}



//
// %%Function: ecParseChar
//
// Route the character to the appropriate destination stream.
//

int ecParseChar(int ch,int param)
{

//	if(ch==0x8) cprintf("parse char %x",ch);

	if(risUnicode) cprintf("unicodeskip %d ris %d parse char %x",unicodeskip,ris,ch);


 if(ris==risBin && --cbBin<=0)
 {
  ris=risNorm;
 }

	if(risUnicode)
	{
	 if(ris!=risBin) unicodeskip--;						// swopped with line below 28/10/2008
		if(unicodeskip<=0) risUnicode=0;				// because swallowing two bytes instead of one
		return(ecOK);
	}


 switch(rds)
 {
    case rdsSkip:
                 // Toss this character.
                 return(ecOK);

 case rdsKeyCode:
                 keycodechar(ch);
                 return(ecOK);

    case rdsFont:
                 fonttablechar(ch);
                 return(ecOK);

   case rdsStyle:
                 styletablechar(ch);
                 return(ecOK);

  case rdsColour:
                 colourtablechar(ch);
                 return(ecOK);

  		case	rdsTabs:
																	tabschar(ch);
																	break;

    case rdsPict:
                 return(ecPictChar(ch));
    
    case rdsNorm:
                 // Output a character. Properties are valid at this point.
                 return(ecPrintChar(ch,param));

         default:
                 // handle other destinations....
                 return(ecOK);
 }


 return(ecOK);
}




/****************************************************************************/


static void * chunk(void * handle,int size,int chunksize)
{
 int length;
 int newsize;


 if(handle==NULL)
 {
  handle=malloc(MAX(chunksize,size));
  if(handle)
  {
   length=_msize(handle);
   memset(((char*)handle),0,length);
  }
 }
 else
 {
  length=_msize(handle);

  if((size>=length) || (length>(size+chunksize)))
  {
   newsize=(size/chunksize+1)*chunksize;

   handle=realloc(handle,newsize);

   if(handle)
   {
    if(newsize>length) memset(((char*)handle)+length,0,newsize-length);
   }
  }
 }

 return(handle);
}




/**********************************************************************************/


#define MAXFNLEN 128

static char   fontname[MAXFNLEN];
static int    fontnum;
static char * fnamep;

int           deffont;


typedef struct fonttablestr
{
 int    fontnum;
 char   fontname[MAXFNLEN];


} fonttablestr;


static fonttablestr * fonttab;
static int            fonttabn;

#define FONTCHUNK (sizeof(fonttablestr)*16)

int fonttablechar(int ch)
{

 if(ch==';')
 {
  if(fnamep>fontname)
  {
   *fnamep=0;
//   cprintf("font %d %s",fontnum,fontname);


   fonttab=(fonttablestr*)chunk(fonttab,MAX(fonttabn,fontnum+1)*sizeof(fonttablestr),FONTCHUNK);
   fonttab[fontnum].fontnum=fontnum;
   strcpy(fonttab[fontnum].fontname,fontname);

   fonttabn=MAX(fonttabn,fontnum+1);
  }
 }
 else
 if(fnamep<(fontname+MAXFNLEN-2) && ch>=' ')
 {
  *fnamep++=ch;
 }

 return(ecOK);
}



int fonttablefamily(int val)
{



 return(ecOK);
}



int fonttablemember(int val)
{

 fnamep=fontname;
 fontnum=val;

 return(ecOK);
}


int fonttablestart(void)
{

 fnamep=fontname;

 return(ecOK);
}


int fonttableend(void)
{


 return(ecOK);
}



void dumpfonttable(void)
{
 int i;

 cprintf("dump fonttable %d",fonttabn);

 for(i=0;i<fonttabn;i++)
 {
//  cprintf("i %d fontname %x fontnum %d",i,fonttab[i].fontname,fonttab[i].fontnum);

  if(fonttab[i].fontname && (*fonttab[i].fontname))
  {
   fprintf(fpout,"FONT_%d={font \"%s\"}\r\n",fonttab[i].fontnum,fonttab[i].fontname);
  }
 }
}


/**********************************************************************************/





static int curred;
static int curgreen;
static int curblue;

typedef struct colourtablestr
{
 int red;
 int green;
 int blue;

} colourtablestr;

static colourtablestr * colourtab;
static int              colourtabn;

#define COLOURCHUNK (sizeof(colourtablestr)*16)

int colourtablechar(int ch)
{

 if(ch==';')
 {
  colourtab=(colourtablestr*)chunk(colourtab,(colourtabn+1)*sizeof(colourtablestr),COLOURCHUNK);
  colourtab[colourtabn].red=curred;
  colourtab[colourtabn].green=curgreen;
  colourtab[colourtabn].blue=curblue;
  colourtabn++;
//  cprintf("coltab %d",colourtabn);
 }

 return(ecOK);
}



int colourtablevalue(int iprop,int val)
{
 if(iprop==ipropColourRed)   curred=val;
 else
 if(iprop==ipropColourGreen) curgreen=val;
 else
 if(iprop==ipropColourBlue)  curblue=val;

 return(ecOK);
}


int colourtablestart(void)
{
 cprintf("col tab start");

 colourtabn=0;

 return(ecOK);
}


int colourtableend(void)
{


 return(ecOK);
}



static void dumpcolourtable(void)
{
 int i;

 cprintf("dump colourtable %d",colourtabn);

 for(i=0;i<colourtabn;i++)
 {
  fprintf(fpout,"COL_%d={colour \"col%d\" {rgb 0x%x 0x%x 0x%x}}\r\n",i,i,(colourtab[i].red*0x10000)/255,(colourtab[i].green*0x10000)/255,(colourtab[i].blue*0x10000)/255);
 }

}


/**********************************************************************************/


int tabschar(int ch)
{
	cprintf("tabs char");

	USE(ch);

 return(ecOK);
}



int tabsvalue(int iprop,int val)
{

	cprintf("tabs value");

	USE(iprop);
	USE(val);

 return(ecOK);
}


int tabscodestart(void)
{

	cprintf("tabs start");

 return(ecOK);
}


int tabscodeend(void)
{

	cprintf("tabs end");

 return(ecOK);
}





/**********************************************************************************/

static int width;
static int height;
static int pixwidth;
static int pixheight;
static int picttype;
static int pictxscale;
static int pictyscale;
static int pictfit;
static int pictlen;
static char * pictdata;
static int pictbyte;
static int pictnibble;


#define DXLEN  80
#define DXQUAD 19

#define DXBASE '#'


static void dxwritedata(char * data,int len)
{

 int           c;
 int           d;

 static int    mask;
 static int    shift;
 static char   buff[DXLEN];
 static char * dxwr;
 static int    quad;
 static int    b;



 if(len==-1)
 {
  mask=0x3;
  shift=2;
  b=0;
  dxwr=buff;
  quad=0;
  *dxwr++='"';
 }
 else
 if(len==-2)
 {
  if(shift>2)
  {
   d=DXBASE+b;
   if(d=='\\') d=DXBASE+64;
   *dxwr++=(char)d;
  }

  if(quad || shift>2)
  {
   *dxwr++='"';
   *dxwr++='\r';
   *dxwr++='\n';
   fwrite(buff,dxwr-buff,1,fpout);
  }
 }
 else
 {
  while(len--)
  {
   c=*data++;

   d=DXBASE+b+(c>>shift);
   if(d=='\\') d=DXBASE+64;
   *dxwr++=(char)d;

   if(shift==6)
   {
    d=DXBASE+(c & 0x3F);
    if(d=='\\') d=DXBASE+64;
    *dxwr++=(char)d;
    shift=2;
    b=0;
    mask=0x3;
    quad++;

    if(quad==DXQUAD)
    {
     *dxwr++='"';
     *dxwr++='\r';
     *dxwr++='\n';
     fwrite(buff,dxwr-buff,1,fpout);
     dxwr=buff+1;
     quad=0;
    }
   }
   else
   {
    b=(c & mask)<<(6-shift);
    if(mask==0x3) mask=0xF;
    shift+=2;
   }
  }
 }


}








int ecPict(IPROP iprop,int val)
{            
 if(rds==rdsPict)
 {
  switch(iprop)
  {
   case       ipropPictemf:
   case       ipropPictpng:
   case      ipropPictjpeg:
   case       ipropPictwmf:
                           picttype=iprop;
                           break;

   case  ipropPictpixwidth:
                           pixwidth=val;
                           break;

   case ipropPictpixheight:
                           pixheight=val;
                           break;

   case ipropPicttwipwidth:
//                           cprintf("twip width");
                           width=val*50;
                           break;

   case ipropPicttwipheight:
                           height=val*50;
                           break;

   case    ipropPictxscale:
//                           cprintf("pict xscale %d",val);
                           pictxscale=(val*0x10000)/100;
                           break;

   case    ipropPictyscale:
                           pictyscale=(val*0x10000)/100;
                           break;

   case       ipropPictfit:
                           pictfit=val;
                           break;

   case   ipropPictcroptop:
   case   ipropPictcropbot:
   case  ipropPictcropleft:
   case ipropPictcropright:
   case ipropPictmetabitmap:
   case ipropPictmetabitmapbpp:
                           break;


  }
 }

 return(ecOK);
}


#define PICTCHUNK 0x10000


int ecPictChar(int ch)
{

 if(ch>='0'&& ch<='9') ch=ch-'0';
 else
 {
  ch=toupper(ch);
  if(ch>='A' && ch<='F') ch=ch-'A'+10;
  else                   ch=0;
 }

 pictbyte=(pictbyte<<4) | ch;

 if(pictnibble)
 {
#ifndef RISCOS
  pictdata=(char*)chunk(pictdata,pictlen,PICTCHUNK);
  pictdata[pictlen++]=pictbyte & 0xFF;
#endif

  pictbyte=0;
 }

 pictnibble^=1;

 return(ecOK);
}



int pictstart(void)
{
 cprintf("pict start");

 txendstring();
 txflushstyle();
 txflushall();

 pictxscale=pictyscale=0x10000;

 width=height=72000;
 pixwidth=pixheight=100;

 pictdata=NULL;
 pictlen=0;
 pictbyte=0;
 pictnibble=0;

 return(ecOK);
}





int pictend(void)
{

 cprintf("pict end");


#ifndef RISCOS

 fprintf(fpout,"{embed\r\n");
 fprintf(fpout,"{pictframe\r\n");
 fprintf(fpout,"{lock 0} {spread 0}\r\n");
 fprintf(fpout,"{fillcolour COL_T 0x10000 0}\r\n");
 fprintf(fpout,"{radius 0}\r\n");
 fprintf(fpout,"{inset 0}\r\n");
 fprintf(fpout,"{textflow 3 1 2834}\r\n");
 fprintf(fpout,"{fcurve {box {x 0}\r\n");
 fprintf(fpout,"{y 0}\r\n");
 fprintf(fpout,"{w %d}\r\n",MulDiv(width,pictxscale,0x10000));
 fprintf(fpout,"{h %d}\r\n",MulDiv(height,pictyscale,0x10000));
 fprintf(fpout,"}}\r\n");
 fprintf(fpout,"{angle 0x0}\r\n");
 fprintf(fpout,"{skew 0x0}\r\n");
 fprintf(fpout,"{picturedata\r\n");
 fprintf(fpout,"{lockmode 0}\r\n");
 fprintf(fpout,"{aspectlock 0}\r\n");
 fprintf(fpout,"{autoscale 1}\r\n");
 fprintf(fpout,"{hide 0}\r\n");
 fprintf(fpout,"{bottomleft 0}\r\n");
 fprintf(fpout,"{x 0}\r\n");
 fprintf(fpout,"{y 0}\r\n");
// fprintf(fpout,"{scale  0x%x}\r\n",pictyscale);
// fprintf(fpout,"{aspect 0x%x}\r\n",MulDiv(0x10000,pictxscale,pictyscale));
 fprintf(fpout,"{angle 0x0}\r\n");
 fprintf(fpout,"{skew 0x0}\r\n");
 fprintf(fpout,"{tile 0 0 0}}\r\n");
 fprintf(fpout,"}\r\n");

 fprintf(fpout,"{picture {scaletofit 1}\r\n");

 if(picttype==ipropPictemf)
 {
  fprintf(fpout,"{data \"Windows Enhanced Metafile\"\r\n");
 }
 else
 if(picttype==ipropPictpng)
 {
  fprintf(fpout,"{data \"png\"\r\n");
 }
 else
 if(picttype==ipropPictjpeg)
 {
  fprintf(fpout,"{data \"jpeg\"\r\n");
 }
 else
 if(picttype==ipropPictwmf)
 {
  fprintf(fpout,"{data \"Windows Metafile\"\r\n");
 }

 fprintf(fpout,"%d\r\n",pictlen);

 dxwritedata(NULL,-1);
 dxwritedata(pictdata,pictlen);
 dxwritedata(NULL,-2);

 fprintf(fpout,"}}\r\n");

 fprintf(fpout,"}\r\n");

#endif


 if(pictdata)
 {
  free(pictdata);
  pictdata=NULL;
 }

 return(ecOK);
}




/**********************************************************************************/


#define MAXSNLEN 128

typedef struct styletablestr
{
 int  type;
 char stylename[MAXSNLEN];
 int  stylenum;

 union
 {
  CHP chp;
  PAP pap;
  SEP sep;

 };


} styletablestr;


#define STYLECHUNK (sizeof(styletablestr)*16)

static styletablestr * styletab;


static int    styletabn;
static char   stylename[MAXSNLEN];
static int    stylenum;
static int    styletype;
static char * snamep;
static int    stylepending;



// this will be called for non-default styles

int styletablemember(int type,int val)
{

// cprintf("style member");

 if(type==ipropCStyle || type==ipropPStyle || type==ipropSStyle)
 {
  snamep=stylename;
  stylenum=val;
  styletype=type;
 }


 return(ecOK);
}


static void styledef(void)
{
 styletablemember(ipropPStyle,0);
}



int styletablechar(int ch)
{

// cprintf("stylechar %d",ch);

 if(ch==';')  // style complete
 {
  if(snamep>stylename)
  {
   *snamep=0;
  }
  else
  {
   sprintf(stylename,"No_name_%d",stylenum);
  }

//  cprintf("style %d %s",stylenum,stylename);


  styletab=(styletablestr*)chunk(styletab,MAX(styletabn,stylenum+1)*sizeof(styletablestr),STYLECHUNK);
  styletab[stylenum].stylenum=stylenum;
  strcpy(styletab[stylenum].stylename,stylename);
  styletab[stylenum].chp=chp;
  styletab[stylenum].pap=pap;
  styletab[stylenum].sep=sep;


  styletabn=MAX(styletabn,stylenum+1);


  styledef();
 }
 else
 if(snamep<(stylename+MAXSNLEN-2) && ch>=' ')
 {
  *snamep++=ch;
 }

 return(ecOK);
}







int styletablestart(void)
{

 cprintf("style start");

 styledef();

 return(ecOK);
}





int styletableend(void)
{


 return(ecOK);
}






int keycodechar(int ch)
{


 return(ecOK);
}



int keycodemember(int type,int val)
{



 return(ecOK);
}



int keycodestart(void)
{

 cprintf("keycode start");

 

 return(ecOK);
}





int keycodeend(void)
{


 return(ecOK);
}





// add style to text type of style, number

void styleadd(int iprop,int val)
{

 sstack.style[sstack.snum]=val;
 sstack.snum++;
 stylechange();
}




// styles for text are reset, remove all styles with property

void stylerem(int iprop)
{
 int r;
 int w;

 for(r=w=0;r<sstack.snum;r++)
 {
  if(styletab[sstack.style[r]].type==iprop)
  {

  }
  else
  {
   if(r!=w) sstack.style[w]=sstack.style[r];
   w++;
  }
 }

 sstack.snum=w;
 stylechange();
}



void stylechange(void)
{
 stylepending=1;
}



static void dumpstyletable(void)
{
 int i;
 int n;
 int body;

 cprintf("dump styletable %d",styletabn);


 for(i=0;i<styletabn;i++)
 {
  if(!cstrcmp(styletab[i].stylename,"BodyText"))
  {
   body=i;
   break;
  }
 }



 if(i<styletabn)
 {
  n=0;

  while(1)
  {
   sprintf(stylename,"BodyText%d",n++);

   for(i=0;i<styletabn;i++)
   {
    if(!cstrcmp(styletab[i].stylename,stylename)) break;
   }

   if(i>=styletabn)
   {
    strcpy(styletab[body].stylename,stylename);
    break;
   }
  }
 }



 for(i=0;i<styletabn;i++)
 {
  if(*styletab[i].stylename)
  {
   fprintf(fpout,"STYLE_%d={style \"%s\"\r\n",i,styletab[i].stylename);


   if(styletab[i].chp.fBold) fprintf(fpout,"{bold 1}\r\n");
   else                      fprintf(fpout,"{bold 0}\r\n");

   if(styletab[i].chp.fItalic) fprintf(fpout,"{italic 1}\r\n");
   else                        fprintf(fpout,"{italic 0}\r\n");

   if(styletab[i].chp.underline) fprintf(fpout,"{underline 1}\r\n");
   else                          fprintf(fpout,"{underline 0}\r\n");


   if(styletab[i].chp.supersub==0) fprintf(fpout,"{super 0}{sub 0}\r\n");
   else
   if(styletab[i].chp.supersub==1) fprintf(fpout,"{super 1}{sub 0}\r\n");
   else
   if(styletab[i].chp.supersub==2) fprintf(fpout,"{super 0}{sub 1}\r\n");



   fprintf(fpout,"{textsize %d}\r\n",styletab[i].chp.fontsize*500);

//   fprintf(fpout," FONT_%d \r\n",styletab[i].chp.font);



//{keypress ""}
//{scope 1}
//{bold 0}
//{italic 0}
//{underline 0 {type 1} {thickness 1310} {colourvalue COL_03 0x10000 0} {wordunderline 0} {doubleunderline 0}}
//{reverse 0}
//{super 0}{sub 0}
//{strikeout 0 {type 1} {thickness 1310} {colourvalue COL_03 0x10000 0}}
//{verticalrule {leftrule 0 0} {rightrule 0 0} {thickness 0} {colourvalue COL_01 0x10000 0}}
//{horizontalrule {aboverule 0 0} {belowrule 0 0} {thickness 0} {colourvalue COL_01 0x10000 0}}
// FONT_b1d0 
//{foreground COL_01 0x10000 0}
//{background COL_03 0x10000 0}
//{textsize 12000}
//{scale 0x10000}
//{track 0x0}
//{baseshift 0x0}
//{align 0}
//{spacebefore 0}
//{spaceafter 0}
//{leading 2 13107}
//{leftindent 1 0}
//{rightindent 1 0}
//{firstindent 0}
//{case 0}
//{drop 0 3}
//{bullet 0 {bulletbefore ""} {bulletafter ""} {bulletstyle ""} {bullettab 1} {bulletstart 1}{bulletformat 0}}
//{hyphenation 0 {hpminsize 5} {hpminbefore 2} {hpminafter 2} {hpmaxconsecutive 3} {hpzone 0} {hpbreakpara 0} {hpbreakcaps 0}}
//{autokern 0}
//{wordwrap 1}
//{index 0}
//{contents 0}
//{level 0}
//{baselinelock 0}
//{smallcaps 0}
//{keeplines 0 0}
//{keeppara 0}
//{keepnext 0}
//{language 0}
//{angle 0x0}
//{skew 0x0}
//{justification 0 {justminletter 0x0} {justmaxletter 0x4000} {justminword 0xc000} {justmaxword 0x14000} {justflushzone 0} {justsinglewords 0}}
//{tabruler {tableader ""} }
   fprintf(fpout,"}\r\n");

//  fprintf(fpout,"COL_%d={colour \"col%d\" {rgb 0x%x 0x%x 0x%x}}\r\n",i,i,(colourtab[i].red*0x10000)/255,(colourtab[i].green*0x10000)/255,(colourtab[i].blue*0x10000)/255);
  }
 }

}





/**********************************************************************************/



//
// %%Function: ecPrintChar
//
// Send a character to the output file.
//


static int txstate;

#define TXNULL    0x0
#define TXSTRING  0x1
#define TXSTORY   0x2
#define TXDOC     0x3





// index is Windows code, value is RISC OS code

static int code8invtab[256]=
{
 0x0,                     /* 0   */
 0x1,                     /* 1   */
 0x2,                     /* 2   */
 0x3,                     /* 3   */
 0x4,                     /* 4   */
 0x5,                     /* 5   */
 0x6,                     /* 6   */
 0x7,                     /* 7   */
 0x8,                     /* 8   */
 0x9,                     /* 9   */
 0xa,                     /* 10   */
 0xb,                     /* 11   */
 0xc,                     /* 12   */
 0xd,                     /* 13   */
 0xe,                     /* 14   */
 0xf,                     /* 15   */
 0x10,                    /* 16   */
 0x11,                    /* 17   */
 0x12,                    /* 18   */
 0x13,                    /* 19   */
 0x14,                    /* 20   */
 0x15,                    /* 21   */
 0x16,                    /* 22   */
 0x17,                    /* 23   */
 0x18,                    /* 24   */
 0x19,                    /* 25   */
 0x1a,                    /* 26   */
 0x1b,                    /* 27   */
 0x1c,                    /* 28   */
 0x1d,                    /* 29   */
 0x1e,                    /* 30   */
 0x1f,                    /* 31   */
 0x20,                    /* 32   */
 0x21,                    /* 33 ! */
 0x22,                    /* 34 " */
 0x23,                    /* 35 # */
 0x24,                    /* 36 $ */
 0x25,                    /* 37 % */
 0x26,                    /* 38 & */
 0x27,                    /* 39 ' */
 0x28,                    /* 40 ( */
 0x29,                    /* 41 ) */
 0x2a,                    /* 42 * */
 0x2b,                    /* 43 + */
 0x2c,                    /* 44 , */
 0x2d,                    /* 45 - */
 0x2e,                    /* 46 . */
 0x2f,                    /* 47 / */
 0x30,                    /* 48 0 */
 0x31,                    /* 49 1 */
 0x32,                    /* 50 2 */
 0x33,                    /* 51 3 */
 0x34,                    /* 52 4 */
 0x35,                    /* 53 5 */
 0x36,                    /* 54 6 */
 0x37,                    /* 55 7 */
 0x38,                    /* 56 8 */
 0x39,                    /* 57 9 */
 0x3a,                    /* 58 : */
 0x3b,                    /* 59 ; */
 0x3c,                    /* 60 < */
 0x3d,                    /* 61 = */
 0x3e,                    /* 62 > */
 0x3f,                    /* 63 ? */
 0x40,                    /* 64 @ */
 0x41,                    /* 65 A */
 0x42,                    /* 66 B */
 0x43,                    /* 67 C */
 0x44,                    /* 68 D */
 0x45,                    /* 69 E */
 0x46,                    /* 70 F */
 0x47,                    /* 71 G */
 0x48,                    /* 72 H */
 0x49,                    /* 73 I */
 0x4a,                    /* 74 J */
 0x4b,                    /* 75 K */
 0x4c,                    /* 76 L */
 0x4d,                    /* 77 M */
 0x4e,                    /* 78 N */
 0x4f,                    /* 79 O */
 0x50,                    /* 80 P */
 0x51,                    /* 81 Q */
 0x52,                    /* 82 R */
 0x53,                    /* 83 S */
 0x54,                    /* 84 T */
 0x55,                    /* 85 U */
 0x56,                    /* 86 V */
 0x57,                    /* 87 W */
 0x58,                    /* 88 X */
 0x59,                    /* 89 Y */
 0x5a,                    /* 90 Z */
 0x5b,                    /* 91 [ */
 0x5c,                    /* 92 \ */
 0x5d,                    /* 93 ] */
 0x5e,                    /* 94 ^ */
 0x5f,                    /* 95 _ */
 0x60,                    /* 96 ` */
 0x61,                    /* 97 a */
 0x62,                    /* 98 b */
 0x63,                    /* 99 c */
 0x64,                    /* 100 d */
 0x65,                    /* 101 e */
// 0x9f,                    /* 102 f */
 0x66,                    /* 102 f */
// 0x9e,                    /* 102 f */
 0x67,                    /* 103 g */
 0x68,                    /* 104 h */
 0x69,                    /* 105 i */
 0x6a,                    /* 106 j */
 0x6b,                    /* 107 k */
 0x6c,                    /* 108 l */
 0x6d,                    /* 109 m */
 0x6e,                    /* 110 n */
 0x6f,                    /* 111 o */
 0x70,                    /* 112 p */
 0x71,                    /* 113 q */
 0x72,                    /* 114 r */
 0x73,                    /* 115 s */
 0x74,                    /* 116 t */
 0x75,                    /* 117 u */
 0x76,                    /* 118 v */
 0x77,                    /* 119 w */
 0x78,                    /* 120 x */
 0x79,                    /* 121 y */
 0x7a,                    /* 122 z */
 0x7b,                    /* 123 { */
 0x7c,                    /* 124 | */
 0x7d,                    /* 125 } */
 0x7e,                    /* 126 ~ */
 0x7f,                    /* 127  */
 0x80,                    /* 128  */
	-1,	  																			/* 129   blank in win */
 -1, /*0x83,*/            /* 130  not in risc os*/
 -1, /*0x8a,*/            /* 131  not in risc os*/
 0x96,                    /* 132  */
 0x8c,                    /* 133  */
 0x9c,                    /* 134  */
 0x9d,                    /* 135  */
 -1, /*0x84,*/            /* 136  not in risc os*/
 0x8e,                    /* 137  */
 -1, /* 0x85, */          /* 138  not in risc os*/
 0x92,                    /* 139  */
 0x9a,                    /* 140  */
	-1,  																				/* 141   blank in win	*/
 -1, /*0x81, */           /* 142  not in risc os*/
	-1,	  																			/* 143   blank in win	*/
 -1, /*0x88 */            /* 144   blank in win */
 0x90,                    /* 145  */
 0x91,                    /* 146  */
 0x94,                    /* 147  */
 0x95,                    /* 148  */
 0x8f,                    /* 149  */
 0x97,                    /* 150  */
// 0x99,                    /* 150  */
 0x98,                    /* 151  */
 -1, /* 0x87,*/           /* 152  not in risc os*/
 0x8d,                    /* 153  */
 -1, /* 0x86,*/           /* 154  not in risc os*/
 0x93,                    /* 155  */
 0x9b,                    /* 156  */
 -1, /* 0x89,*/           /* 157   blank in win */
 -1, /* 0x82,*/           /* 158  not in risc os*/
 -1, /* 0x8b,*/           /* 159  not in risc os*/
 0xa0,                    /* 160 NBSP */
 0xa1,                    /* 161  */
 0xa2,                    /* 162  */
 0xa3,                    /* 163  */
 0xa4,                    /* 164  */
 0xa5,                    /* 165  */
 0xa6,                    /* 166  */
 0xa7,                    /* 167  */
 0xa8,                    /* 168  */
 0xa9,                    /* 169  */
 0xaa,                    /* 170  */
 0xab,                    /* 171  */
 0xac,                    /* 172  */
 0xad,                    /* 173  */
 0xae,                    /* 174  */
 0xaf,                    /* 175  */
 0xb0,                    /* 176  */
 0xb1,                    /* 177  */
 0xb2,                    /* 178  */
 0xb3,                    /* 179  */
 0xb4,                    /* 180  */
 0xb5,                    /* 181  */
 0xb6,                    /* 182  */
 0xb7,                    /* 183 + */
 0xb8,                    /* 184 + */
 0xb9,                    /* 185  */
 0xba,                    /* 186  */
 0xbb,                    /* 187 + */
 0xbc,                    /* 188 + */
 0xbd,                    /* 189 + */
 0xbe,                    /* 190 + */
 0xbf,                    /* 191 + */
 0xc0,                    /* 192 + */
 0xc1,                    /* 193 - */
 0xc2,                    /* 194 - */
 0xc3,                    /* 195 + */
 0xc4,                    /* 196 - */
 0xc5,                    /* 197 + */
 0xc6,                    /* 198  */
 0xc7,                    /* 199  */
 0xc8,                    /* 200 + */
 0xc9,                    /* 201 + */
 0xca,                    /* 202 - */
 0xcb,                    /* 203 - */
 0xcc,                    /* 204  */
 0xcd,                    /* 205 - */
 0xce,                    /* 206 + */
 0xcf,                    /* 207 - */
 0xd0,                    /* 208 - */
 0xd1,                    /* 209 - */
 0xd2,                    /* 210 - */
 0xd3,                    /* 211 + */
 0xd4,                    /* 212 + */
 0xd5,                    /* 213 + */
 0xd6,                    /* 214 + */
 0xd7,                    /* 215 + */
 0xd8,                    /* 216 + */
 0xd9,                    /* 217 + */
 0xda,                    /* 218 + */
 0xdb,                    /* 219  */
 0xdc,                    /* 220 _ */
 0xdd,                    /* 221  */
 0xde,                    /* 222  */
 0xdf,                    /* 223  */
 0xe0,                    /* 224 a */
 0xe1,                    /* 225  */
 0xe2,                    /* 226 G */
 0xe3,                    /* 227 p */
 0xe4,                    /* 228 S */
 0xe5,                    /* 229 s */
 0xe6,                    /* 230  */
 0xe7,                    /* 231 t */
 0xe8,                    /* 232 F */
 0xe9,                    /* 233 T */
 0xea,                    /* 234 O */
 0xeb,                    /* 235 d */
 0xec,                    /* 236 8 */
 0xed,                    /* 237 f */
 0xee,                    /* 238 e */
 0xef,                    /* 239 n */
 0xf0,                    /* 240 = */
 0xf1,                    /* 241  */
 0xf2,                    /* 242 = */
 0xf3,                    /* 243 = */
 0xf4,                    /* 244 ( */
 0xf5,                    /* 245 ) */
 0xf6,                    /* 246  */
 0xf7,                    /* 247  */
 0xf8,                    /* 248  */
 0xf9,                    /* 249  */
 0xfa,                    /* 250  */
 0xfb,                    /* 251 v */
 0xfc,                    /* 252 n */
 0xfd,                    /* 253  */
 0xfe,                    /* 254  */
 0xff                     /* 255  */
};





static char code8symbolinvtab[256]=
{
 0x0,                     /* 0   */
 0x1,                     /* 1   */
 0x2,                     /* 2   */
 0x3,                     /* 3   */
 0x4,                     /* 4   */
 0x5,                     /* 5   */
 0x6,                     /* 6   */
 0x7,                     /* 7   */
 0x8,                     /* 8   */
 0x9,                     /* 9   */
 0xa,                     /* 10   */
 0xb,                     /* 11   */
 0xc,                     /* 12   */
 0xd,                     /* 13   */
 0xe,                     /* 14   */
 0xf,                     /* 15   */
 0x10,                    /* 16   */
 0x11,                    /* 17   */
 0x12,                    /* 18   */
 0x13,                    /* 19   */
 0x14,                    /* 20   */
 0x15,                    /* 21   */
 0x16,                    /* 22   */
 0x17,                    /* 23   */
 0x18,                    /* 24   */
 0x19,                    /* 25   */
 0x1a,                    /* 26   */
 0x1b,                    /* 27   */
 0x1c,                    /* 28   */
 0x1d,                    /* 29   */
 0x1e,                    /* 30   */
 0x1f,                    /* 31   */
 0x20,                    /* 32   */
 0x21,                    /* 33 ! */
 0x22,                    /* 34 " */
 0x23,                    /* 35 # */
 0x24,                    /* 36 $ */
 0x25,                    /* 37 % */
 0x26,                    /* 38 & */
 0x27,                    /* 39 ' */
 0x28,                    /* 40 ( */
 0x29,                    /* 41 ) */
 0x2a,                    /* 42 * */
 0x2b,                    /* 43 + */
 0x2c,                    /* 44 , */
 0x2d,                    /* 45 - */
 0x2e,                    /* 46 . */
 0x2f,                    /* 47 / */
 0x30,                    /* 48 0 */
 0x31,                    /* 49 1 */
 0x32,                    /* 50 2 */
 0x33,                    /* 51 3 */
 0x34,                    /* 52 4 */
 0x35,                    /* 53 5 */
 0x36,                    /* 54 6 */
 0x37,                    /* 55 7 */
 0x38,                    /* 56 8 */
 0x39,                    /* 57 9 */
 0x3a,                    /* 58 : */
 0x3b,                    /* 59 ; */
 0x3c,                    /* 60 < */
 0x3d,                    /* 61 = */
 0x3e,                    /* 62 > */
 0x3f,                    /* 63 ? */
 0x40,                    /* 64 @ */
 0x41,                    /* 65 A */
 0x42,                    /* 66 B */
 0x43,                    /* 67 C */
 0x44,                    /* 68 D */
 0x45,                    /* 69 E */
 0x46,                    /* 70 F */
 0x47,                    /* 71 G */
 0x48,                    /* 72 H */
 0x49,                    /* 73 I */
 0x4a,                    /* 74 J */
 0x4b,                    /* 75 K */
 0x4c,                    /* 76 L */
 0x4d,                    /* 77 M */
 0x4e,                    /* 78 N */
 0x4f,                    /* 79 O */
 0x50,                    /* 80 P */
 0x51,                    /* 81 Q */
 0x52,                    /* 82 R */
 0x53,                    /* 83 S */
 0x54,                    /* 84 T */
 0x55,                    /* 85 U */
 0x56,                    /* 86 V */
 0x57,                    /* 87 W */
 0x58,                    /* 88 X */
 0x59,                    /* 89 Y */
 0x5a,                    /* 90 Z */
 0x5b,                    /* 91 [ */
 0x5c,                    /* 92 \ */
 0x5d,                    /* 93 ] */
 0x5e,                    /* 94 ^ */
 0x5f,                    /* 95 _ */
 0x60,                    /* 96 ` */
 0x61,                    /* 97 a */
 0x62,                    /* 98 b */
 0x63,                    /* 99 c */
 0x64,                    /* 100 d */
 0x65,                    /* 101 e */
 0x66,                    /* 102 f */
 0x67,                    /* 103 g */
 0x68,                    /* 104 h */
 0x69,                    /* 105 i */
 0x6a,                    /* 106 j */
 0x6b,                    /* 107 k */
 0x6c,                    /* 108 l */
 0x6d,                    /* 109 m */
 0x6e,                    /* 110 n */
 0x6f,                    /* 111 o */
 0x70,                    /* 112 p */
 0x71,                    /* 113 q */
 0x72,                    /* 114 r */
 0x73,                    /* 115 s */
 0x74,                    /* 116 t */
 0x75,                    /* 117 u */
 0x76,                    /* 118 v */
 0x77,                    /* 119 w */
 0x78,                    /* 120 x */
 0x79,                    /* 121 y */
 0x7a,                    /* 122 z */
 0x7b,                    /* 123 { */
 0x7c,                    /* 124 | */
 0x7d,                    /* 125 } */
 0x7e,                    /* 126 ~ */
 0x7f,                    /* 127  */
 0x80,                    /* 128  */
	      0x81,	   										/* 129 x81  blank in win */
       0x82,              /* 130 x82  not in risc os*/
       0x83,              /* 131 x83  not in risc os*/
 0x96,                    /* 132 x84  */
 0x8c,                    /* 133 x85  */
 0x9c,                    /* 134 x86  */
 0x9d,                    /* 135 x87  */
       0x88,              /* 136 x88  not in risc os*/
 0x8e,                    /* 137 x89  */
       0x8a,              /* 138 x8a  not in risc os*/
 0x92,                    /* 139 x8b  */
 0x9a,                    /* 140 x8c  */
	      0x84,														/* 141 x8d  blank in win	*/
       0x85,              /* 142 x8e  not in risc os*/
       0x86,	 												/* 143 x8f  blank in win	*/
       0x87,              /* 144 x90  blank in win */
 0x90,                    /* 145 x91  */
 0x91,                    /* 146 x92  */
 0x94,                    /* 147 x93  */
 0x95,                    /* 148 x94  */
 0x8f,                    /* 149 x95  */
 0x97, /* 151*/           /* 150 x96  */
 0x98, /* 152*/           /* 151 x97  */
       0x89,              /* 152 x98  not in risc os*/
 0x8d,                    /* 153 x99  */
       0x8b,              /* 154 x9a  not in risc os*/
 0x93,                    /* 155 x9b  */
 0x9b,                    /* 156 x9c  */
       0x99,/*153*/       /* 157 x9d  blank in win */
       0x9e,              /* 158 x9e  not in risc os*/
       0x9f,              /* 159 x9f  not in risc os*/
 0xa0,                    /* 160 NBSP */
 0xa1,                    /* 161  */
 0xa2,                    /* 162  */
 0xa3,                    /* 163  */
 0xa4,                    /* 164  */
 0xa5,                    /* 165  */
 0xa6,                    /* 166  */
 0xa7,                    /* 167  */
 0xa8,                    /* 168  */
 0xa9,                    /* 169  */
 0xaa,                    /* 170  */
 0xab,                    /* 171  */
 0xac,                    /* 172  */
 0xad,                    /* 173  */
 0xae,                    /* 174  */
 0xaf,                    /* 175  */
 0xb0,                    /* 176  */
 0xb1,                    /* 177  */
 0xb2,                    /* 178  */
 0xb3,                    /* 179  */
 0xb4,                    /* 180  */
 0xb5,                    /* 181  */
 0xb6,                    /* 182  */
 0xb7,                    /* 183 + */
 0xb8,                    /* 184 + */
 0xb9,                    /* 185  */
 0xba,                    /* 186  */
 0xbb,                    /* 187 + */
 0xbc,                    /* 188 + */
 0xbd,                    /* 189 + */
 0xbe,                    /* 190 + */
 0xbf,                    /* 191 + */
 0xc0,                    /* 192 + */
 0xc1,                    /* 193 - */
 0xc2,                    /* 194 - */
 0xc3,                    /* 195 + */
 0xc4,                    /* 196 - */
 0xc5,                    /* 197 + */
 0xc6,                    /* 198  */
 0xc7,                    /* 199  */
 0xc8,                    /* 200 + */
 0xc9,                    /* 201 + */
 0xca,                    /* 202 - */
 0xcb,                    /* 203 - */
 0xcc,                    /* 204  */
 0xcd,                    /* 205 - */
 0xce,                    /* 206 + */
 0xcf,                    /* 207 - */
 0xd0,                    /* 208 - */
 0xd1,                    /* 209 - */
 0xd2,                    /* 210 - */
 0xd3,                    /* 211 + */
 0xd4,                    /* 212 + */
 0xd5,                    /* 213 + */
 0xd6,                    /* 214 + */
 0xd7,                    /* 215 + */
 0xd8,                    /* 216 + */
 0xd9,                    /* 217 + */
 0xda,                    /* 218 + */
 0xdb,                    /* 219  */
 0xdc,                    /* 220 _ */
 0xdd,                    /* 221  */
 0xde,                    /* 222  */
 0xdf,                    /* 223  */
 0xe0,                    /* 224 a */
 0xe1,                    /* 225  */
 0xe2,                    /* 226 G */
 0xe3,                    /* 227 p */
 0xe4,                    /* 228 S */
 0xe5,                    /* 229 s */
 0xe6,                    /* 230  */
 0xe7,                    /* 231 t */
 0xe8,                    /* 232 F */
 0xe9,                    /* 233 T */
 0xea,                    /* 234 O */
 0xeb,                    /* 235 d */
 0xec,                    /* 236 8 */
 0xed,                    /* 237 f */
 0xee,                    /* 238 e */
 0xef,                    /* 239 n */
 0xf0,                    /* 240 = */
 0xf1,                    /* 241  */
 0xf2,                    /* 242 = */
 0xf3,                    /* 243 = */
 0xf4,                    /* 244 ( */
 0xf5,                    /* 245 ) */
 0xf6,                    /* 246  */
 0xf7,                    /* 247  */
 0xf8,                    /* 248  */
 0xf9,                    /* 249  */
 0xfa,                    /* 250  */
 0xfb,                    /* 251 v */
 0xfc,                    /* 252 n */
 0xfd,                    /* 253  */
 0xfe,                    /* 254  */
 0xff                     /* 255  */
};









#define QLEN 80


static char   * txbase;
static char   * txp;
static char   * txbrk;
static char   * txqbrk;
static char   * txsplit;
static char     buff[4*QLEN];



CHP rchp;
PAP rpap;
SEP rsep;
DOP rdop;



//typedef os_error * (*codetextfn)(char * p,filestr * file);


typedef struct codetextstr
{
 void * name;
 int    len;
} codetextstr;





static codetextstr codetexttable[32]=
{
 "{endoftext}",    11,   /* 0 EOT        */
  NULL,            0,    /* 1 blank      */
 "{newframe}",     10,   /* 2 end of box */
 "{newpage}",      9,    /* 3            */
 "{chapterno}",    11,   /* 4            */
 "{activedate}",   12,   /* 5            */
 NULL,             0,    /* 6 bullet     */
 NULL,             0,    /* 7 blank      */ 
 NULL,             0,    /* 8 blank      */
 "{tab}",          5,    /* 9 tab        */
 "{newpara}",      9,    /* 10           */
 NULL,             0,    /* 11 blank     */ 
 NULL,             0,    /* 12 blank     */
 "{newline}",      9,    /* 13           */
 NULL,             0,    /* 14 blank     */
 NULL,             0,    /* 15 blank     */ 
 NULL,             0,    /* 16 blank     */ 
 NULL,             0,    /* 17 blank     */
 NULL,             0,    /* 18           */
 NULL,             0,    /* 19 mail tag  */
 NULL,             0,    /* 20 style     */
 "{softhyphen}",   12,   /* 21 disc hyphen */
 "",              1,    /* 22 nb hyphen */
 NULL,             0,    /* 23 blank     */
 NULL,             0,    /* 24 blank     */ 
 NULL,             0,    /* 25 blank     */
 NULL,             0,    /* 26 blank     */ 
 NULL,             0,    /* 27 blank     */ 
 NULL,             0,    /* 28 blank     */
 NULL,             0,    /* 29 blank     */
 "{pageno}",       8,    /* 30 page no   */
 NULL,             0,    /* 31 blank     */
};




static void txflushall(void)
{

 if(txp>txbase)
 {
 	*txp++='\r';
  *txp++='\n';
  fwrite(txbase,txp-txbase,1,fpout);
  txp=txsplit=txbase;
 }
}




static void txflush(int split)
{
 int c1;
 int c2;
	int c3;

 if(txstate!=TXSTRING)
 {
  if(txp>=txbrk)
  {
   if(txsplit>txbase)
   {
    c1=*txsplit;
    c2=*(txsplit+1);
    *txsplit='\r';
    *(txsplit+1)='\n';
    fwrite(txbase,txsplit-txbase+2,1,fpout);
    *txsplit=(char)c1;
    *(txsplit+1)=(char)c2;
    memmove(txbase,txsplit,txp-txsplit);
    txp=txbase+(txp-txsplit);
    txsplit=txbase;
   }
   else
   {
				*txp++='\r';
    *txp++='\n';
    fwrite(txbase,txp-txbase,1,fpout);
    txp=txsplit=txbase;
   }

//  cprintf("flush txp %x txbase %x",txp,txbase);
  }
 }
 else
 {
  if(txp>=txqbrk)
  {
   if(txsplit>txbase)
   {
    c1=*txsplit;
    c2=*(txsplit+1);
    c3=*(txsplit+2);
    *txsplit='"';
    *(txsplit+1)='\r';
    *(txsplit+2)='\n';
    fwrite(txbase,txsplit-txbase+3,1,fpout);
    *txsplit=(char)c1;
    *(txsplit+1)=(char)c2;
    *(txsplit+2)=(char)c3;
    memmove(txbase+1,txsplit,txp-txsplit);
    txp=txbase+1+(txp-txsplit);
    *txbase='"';
    txsplit=txbase;
   }
   else
   {
    *txp++='"';
				*txp++='\r';
    *txp++='\n';
    fwrite(txbase,1,txp-txbase,fpout);
    txp=txsplit=txbase;
    *txp++='"';
   }
  }
 }

 if(split) txsplit=txp;


}










static void txstartdoc(void)
{

 fprintf(fpout,"rtf_doc={document}\r\n");

 dumpfonttable();

 fprintf(fpout,"COL_B={colour \"Black\" {cmyk 0x0 0x0 0x0 0x10000}{lock 1}{overprintlimit 0xe666}}\r\n");
 fprintf(fpout,"COL_W={colour \"White\" {rgb 0x10000 0x10000 0x10000}{lock 1}{overprintlimit 0xe666}}\r\n");
 fprintf(fpout,"COL_T={colour \"Transparent\" {rgb 0x10000 0x10000 0x10000}{transparent 1}{lock 1}{overprintlimit 0xe666}}\r\n");
 dumpcolourtable();

 dumpstyletable();



 fprintf(fpout,"CHAP_112={chapter {papersize \"A4\" 0 {w 595276} {h 841890} {sideways 0}}\r\n");
 fprintf(fpout,"{omitheader 0} {omitfooter 0}\r\n");
 fprintf(fpout,"{chapternumber 1}\r\n");
 fprintf(fpout,"{pagenumberformat 2}\r\n");
 fprintf(fpout,"{startonleft 0}\r\n");
 fprintf(fpout,"}\r\n");

 fprintf(fpout,"PAGE_10d={masterpage {colourvalue COL_T 0x10000 0}}\r\n");

 fprintf(fpout,"TEXT_10e={textframe\r\n");
 fprintf(fpout,"{lock 0} {spread 0}\r\n");
 fprintf(fpout,"{masterframe 1}\r\n");
 fprintf(fpout,"{fillcolour COL_W 0x10000 0}\r\n");
 fprintf(fpout,"{radius 0}\r\n");
 fprintf(fpout,"{columns 1}{gutterwidth 14173}{columnguides 0 {thickness 2834} {colourvalue COL_B 0x10000 0}}\r\n");
 fprintf(fpout,"{vertalign 0}\r\n");
 fprintf(fpout,"{firstline 0}\r\n");
 fprintf(fpout,"{inset 2834}\r\n");
 fprintf(fpout,"{textflow 3 1 2834}\r\n");
 fprintf(fpout,"{fcurve {box {x 28346}\r\n");
 fprintf(fpout,"{y 28346}\r\n");
 fprintf(fpout,"{w 538584}\r\n");
 fprintf(fpout,"{h 785198}\r\n");
 fprintf(fpout,"}}\r\n");
 fprintf(fpout,"{angle 0x0}\r\n");
 fprintf(fpout,"{skew 0x0}\r\n");
 fprintf(fpout,"}\r\n");

 fprintf(fpout,"PAGE_113={page}\r\n");

 fprintf(fpout,"TEXT_114={textframe\r\n");
 fprintf(fpout,"{master TEXT_10e}{local 0}\r\n");
 fprintf(fpout,"}\r\n");



	txstate=TXDOC;

}


static void txenddoc(void)
{



	txstate=TXNULL;
}



static void txstartstory(void)
{
	txstate=TXSTORY;


 txbase=txp=txsplit=buff;

 txbrk=txbase+QLEN;
 txqbrk=txbrk-1;

 fprintf(fpout,"story_0={story\r\n");


}


static void txendstory(void)
{

 txflushall();
	txstate=TXDOC;
 fprintf(fpout,"}\r\n");

}




static void txstartstring(void)
{

 if(txstate!=TXSTRING)
 {
  if(txp>txbase)
  {
			*txp++='\r';
   *txp++='\n';
   fwrite(txbase,txp-txbase,1,fpout);
   txp=txbase;
  }
  txsplit=txp;
	 txstate=TXSTRING;
  *txp++='"';
 }


}



static void txendstring(void)
{

 if(txstate==TXSTRING)
 {
  if(txp>(txbase+1))
  {
   *txp++='"';
			*txp++='\r';
   *txp++='\n';
   fwrite(txbase,txp-txbase,1,fpout);
  }
  txp=txsplit=txbase;

 	txstate=TXSTORY;
 }
}




void txstateinit(int content)
{
	if(content) 	txstate=TXDOC;
	else        	txstate=TXNULL;

}


void txstatefinit(int content)
{
	if(txstate==TXSTRING) txendstring();
	if(txstate==TXSTORY)  txendstory();
	if((txstate==TXDOC) && (content==0)) txenddoc();

}



static void txflushstyle(void)
{
 if(stylepending)
 {
 	if(txstate==TXSTRING) txendstring();

  if(chp.fBold!=rchp.fBold)
  {
   if(!chp.fBold) txp+=sprintf(txp,"{bold 0}");
   else           txp+=sprintf(txp,"{bold 1}");
   rchp.fBold=chp.fBold;
  }

  if(chp.fItalic!=rchp.fItalic)
  {
   if(!chp.fItalic) txp+=sprintf(txp,"{italic 0}");
   else             txp+=sprintf(txp,"{italic 1}");
   rchp.fItalic=chp.fItalic;
  }

  if(chp.fontsize!=rchp.fontsize)
  {
   txp+=sprintf(txp,"{textsize %d}",chp.fontsize*500);

   rchp.fontsize=chp.fontsize;
  }

  if(chp.font!=rchp.font)
  {
   txp+=sprintf(txp," FONT_%d ",chp.font);
   rchp.font=chp.font;
  }

  if(chp.underline!=rchp.underline)
  {
   if(!chp.underline) txp+=sprintf(txp,"{underline 0}");
   else               txp+=sprintf(txp,"{underline 1}");
   rchp.underline=chp.underline;
  }

  if(chp.supersub!=rchp.supersub)
  {
   if(chp.supersub==0) txp+=sprintf(txp,"{super 0}{sub 0}");
   else
   if(chp.supersub==1) txp+=sprintf(txp,"{super 1}{sub 0}");
   else
   if(chp.supersub==2) txp+=sprintf(txp,"{super 0}{sub 1}");

   rchp.supersub=chp.supersub;
  }


  if(pap.just!=rpap.just)
  {
   if(pap.just==justL) txp+=sprintf(txp,"{align 0}");
   else
   if(pap.just==justR) txp+=sprintf(txp,"{align 2}");
   else
   if(pap.just==justC) txp+=sprintf(txp,"{align 1}");
   else
   if(pap.just==justF) txp+=sprintf(txp,"{align 3}");

   rpap.just=pap.just;
  }


  stylepending=0;
 }
}





// anything over 32 is in Windows char set
// anything under is an index into codetexttable

int ecPrintChar(int ch,int param)
{

// if(ch>0x80) cprintf("%c param %x inv %x",ch,param,code8symbolinvtab[ch]);

	if(txstate==TXNULL)  txstartdoc();
	if(txstate==TXDOC)   txstartstory();

 if(ch>=32)
 {
  txflushstyle();
  txstartstring();

  if(ch=='"' || ch=='\\') *txp++='\\';
  *txp++=code8symbolinvtab[ch];

//		*txp=0;
//		if(ch>0x80) cprintf("%s",txbase);

  txflush(ch==32);
 }
 else
 {
  txendstring();
  txflushstyle();


//		if(ch==8) cprintf("unicode sighted");

  if(codetexttable[ch].len)
  {
   strcpy(txp,(char*)codetexttable[ch].name);
   txp+=codetexttable[ch].len;
  }
  else
  {
#ifndef RISCOS

			if(ch==8)
			{
				txp+=sprintf(txp,"{u 0x%x}",param & 0xFFFF);
			}

#endif

//   textfn=(codetextfn)codetexttable[c].name;
//     if(textfn) textfn(p,file);
  }

  txflush(1);
 }


// putchar(ch);
 return ecOK;
}
 








int rtfmain(char * infile,char * outfile,int content)
{
 int    ec;
 FILE * fpin;

 fpin=fopen(infile,"r");
 if(!fpin)
 {
  raiseerror("Can't open %s\n",infile);
 }

	fpout=fopen(outfile,"wb");
	if(!fpout)
	{
		raiseerror("Can't open %s\n",outfile);
	}

	txstateinit(content);

 if((ec=ecRtfParse(fpin))!=ecOK)
	{
  cprintf("error %d parsing rtf", ec);
	}
 else
 {
  cprintf("Parsed RTF file OK");
	}

	txstatefinit(content);

 fclose(fpin);
	fclose(fpout);

 return(0);
}

